accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from accounts.views import signup

urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

companys/urls.py
from django.urls import path

from companys.views import (
    CompanyListView,
)

urlpatterns = [
    path("", CompanyListView.as_view(), name="list_companys"),
]

projects/urls.py
from django.urls import path

from projects.views import (
    ProjectListView,
    ProjectDetailView,
    ProjectCreateView,
    ProjectUpdateView,
)

urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
    path(
        "<int:pk>/complete/",
        ProjectUpdateView.as_view(),
        name="complete_project",
    ),
]

tasks/urls.py
from django.urls import path

from tasks.views import (
    TaskCreateView,
    TaskListView,
    TaskUpdateView,
)

urlpatterns = [
    path("create/", TaskCreateView.as_view(), name="create_task"),
    path("mine/", TaskListView.as_view(), name="show_my_tasks"),
    path("<int:pk>/complete/", TaskUpdateView.as_view(), name="complete_task"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView

urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("list_projects")),
        name="home",
    ),
    path("accounts/", include("accounts.urls")),
    path("tasks/", include("tasks.urls")),
    path("company/", include("companys.urls")),
]

companys/models.py
from django.db import models
from django.conf import settings

USER_NAME = settings.AUTH_USER_MODEL


# Create your models here.
class Company(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()

    # projects = models.ManyToManyField(
    #     "projects.Project", related_name="company"
    # )
    employees = models.ForeignKey(
        USER_NAME,
        related_name="company",
        default=None,
        on_delete=models.PROTECT,
    )

    def __str__(self):
        return self.name

projects/models.py
from django.db import models
from django.conf import settings

USER_NAME = settings.AUTH_USER_MODEL

# Create your models here.
class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    is_private = models.BooleanField(default=False)
    is_completed = models.BooleanField(default=False)
    members = models.ManyToManyField(USER_NAME, related_name="projects")
    company = models.ForeignKey(
        "companys.Company",
        default=1,
        related_name="projects",
        on_delete=models.PROTECT,
    )

    def __str__(self):
        return self.name

tasks/models.py
from django.db import models
from django.conf import settings

USER_NAME = settings.AUTH_USER_MODEL

# Create your models here.
class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField(auto_created=True)
    due_date = models.DateTimeField()
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        "projects.Project", related_name="tasks", on_delete=models.CASCADE
    )
    assignee = models.ForeignKey(
        USER_NAME, null=True, related_name="tasks", on_delete=models.SET_NULL
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth import login
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm

# Create your views here.


def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            username = request.POST.get("username")
            password = request.POST.get("password1")
            user = User.objects.create_user(
                username=username, password=password
            )
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm()

    context = {"form": form}
    return render(request, "registration/signup.html", context)

companys/views.py
from django.shortcuts import render
from companys.models import Company
from projects.models import Project
from django.views.generic import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.http import HttpResponse

# Create your views here.


class CompanyListView(LoginRequiredMixin, ListView):
    model = Company
    template_name = "company/c_list.html"
    context_object_name = "company_list"

projects/views.py
from projects.models import Project
from django.views.generic import ListView, DetailView, CreateView, UpdateView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse, reverse_lazy
from companys.models import Company

# Create your views here.
class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "projects/list.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        print(context)
        return context

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectDetailView(LoginRequiredMixin, DetailView):
    model = Project
    template_name = "projects/detail.html"

    # def get_context_data(self, **kwargs):
    #     context = super().get_context_data(**kwargs)
    #     print(context)
    #     return context


class ProjectCreateView(LoginRequiredMixin, CreateView):
    model = Project
    template_name = "projects/new.html"
    fields = ["name", "description", "members"]

    def get_queryset(self):
        return Company.objects.filter(company_id=self.request.user)

    def get_success_url(self):
        return reverse("show_project", args=[self.object.pk])


class ProjectUpdateView(UpdateView):
    model = Project
    fields = ["is_completed"]
    success_url = reverse_lazy("list_projects")

tasks/views.py
from tasks.models import Task
from django.views.generic import CreateView, ListView, UpdateView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy, reverse


# Create your views here.


class TaskCreateView(LoginRequiredMixin, CreateView):
    model = Task
    template_name = "tasks/new_task.html"
    fields = ["name", "start_date", "due_date", "project", "assignee"]

    def get_success_url(self):
        return reverse("show_project", args=[self.object.project_id])


class TaskListView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks/task_list.html"

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)


class TaskUpdateView(UpdateView):
    model = Task
    fields = ["is_completed"]
    success_url = reverse_lazy("show_my_tasks")

companys/templates/company/c_list.html
{% extends 'base.html' %}
{% block content %}
<main>
    <div class="project-list">
        <h1>Company Overview</h1>
        {% for company in company_list %}
        <h3>{{ company.name }}</h3>
        
        {% if company_list|length > 0 %}
        <table>
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Is complete</th>
                    <th>Owner</th>
                </tr>
            </thead>
            <tbody>
                {% for company in company_list %}
                    {% for project in company.projects.all %}
                        <tr>
                            <td><a href="{% url 'show_project' project.pk %}">{{ project.name }}</a></td>
                            <td>{{ project.is_completed }}</td>
                            <td><a href="{% url 'list_projects' %}">{{ project.members.all }}</a></td>
                        </tr>
                    {% endfor %}
                {% endfor %}
            </tbody>
        </table>
        {% else %}
        <p>You are not assigned to any projects</p>
        {% endif %}
        {% endfor %}
    </div>
</main>
{% endblock content %}

projects/templates/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Projects</title>
        {% load static %}
        <link rel="stylesheet" href="{% static 'css/style.css' %}"> 
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_authenticated %}
                        <li><a href="{% url 'list_companys' %}">My Company</a></li>
                        <li><a href="{% url 'list_projects' %}">My Projects</a></li>
                        <li><a href="{% url 'show_my_tasks' %}">My Tasks</a></li>
                        <li><a href="{% url 'logout' %}">Logout</a></li>
                    {% else %}
                        <li><a href="{% url 'login' %}">Login</a></li>
                        <li><a href="{% url 'signup' %}">Signup</a></li>
                    {% endif %}
                </ul>
            </nav>
        </header>
        {% block content %}
        {% endblock content %}
    </body>
</html>

projects/templates/projects/detail.html
{% extends 'base.html' %}
{% load markdownify %}
{% block content %}
    <main>
        <div class="project-detail">
            <h1>{{ project.name }}</h1>
            <p>{{ project.description|markdownify }}</p>
            
            <p>{% if project.is_completed %}Project is done{% else %}<form method="post" action="{% url 'complete_project' project.id %}">
                    {% csrf_token %}
                    <input type="hidden" name="is_completed" value="True">
                    <button>Complete Project</button>
                </form>{% endif %}</p>

            <h2>Tasks</h2>
            <p><a href="{% url 'create_task' %}">Create a new task</a></p>
            {% if project.tasks.all|length > 0 %}
                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Assignee</th>
                            <th>Start date</th>
                            <th>Due date</th>
                            <th>Is completed</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for task in project.tasks.all %}
                            <tr>
                                <td>{{ task.name }}</td>
                                <td>{{ task.assignee }}</td>
                                <td>{{ task.start_date }}</td>
                                <td>{{ task.due_date }}</td>
                                <td>{{ task.is_completed }}</td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            {% else %}
                <p>This project has no tasks</p>
            {% endif %}
        </div>
    </main>
{% endblock content %}

projects/templates/projects/list.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div class="project-list">
            <h1>My Projects</h1>
            <p><a href="{% url 'create_project' %}">Create a new project</a></p>
            {% if project_list|length == 0 %}
                <p>You are not assigned to any projects</p>
            {% else %}
                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Number of tasks</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for project in project_list %}
                            {% if not project.is_completed %}
                            <tr>
                                <td><a href="{% url 'show_project' project.pk %}">{{ project.name }}</a></td>
                                <td>{{ project.tasks.all|length }}</td>
                            </tr>
                            {% endif %}
                        {% endfor %}
                    </tbody>
                </table>
            {% endif %}
        </div><br>

        <div class="project-list">
            <h1>Completed projects</h1>
            <table>
                <thead>
                    <tr>
                        <th>Name</th>
                    </tr>
                </thead>
                <tbody>
                    {% for project in project_list %}
                        {% if project.is_completed %}
                        <tr>
                            <th>{{ project.name }}</th>
                        </tr>
                        {% endif %}
                    {% endfor %}
                </tbody>
            </table>
        </div>
    </main>
{% endblock content %}

projects/templates/projects/new.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div class="project-form">
            <h1>Create a new project</h1>
            <form method="POST">
                {% csrf_token %}
                {{ form.as_p }}
                <button>Create</button>
            </form>
        </div>
    </main>
{% endblock content %}

tasks/templates/tasks/new_task.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div class="task-form">
            <h1>Create a new task</h1>
            <form method="POST">
                {% csrf_token %}
                {{ form.as_p }}
                <button>Create</button>
            </form>
        </div>
    </main>
{% endblock content %}

tasks/templates/tasks/task_list.html
{% extends 'base.html' %}
{% block content %}
    <main>
        <div class="my-tasks-list">
            <h1>My Tasks</h1>
            {% if task_list|length > 0 %}
                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Project</th>
                            <th>Start Date</th>
                            <th>End date</th>
                            <th>Completion</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for task in task_list %}
                            <tr>
                                <td>{{ task.name }}</td>
                                <td>{{ task.project }}</td>
                                <td>{{ task.start_date }}</td>
                                <td>{{ task.due_date }}</td>
                                <td>{% if task.is_completed %}Done{% else %}<form method="post" action="{% url 'complete_task' task.id %}">
                                    {% csrf_token %}
                                    <input type="hidden" name="is_completed" value="True">
                                    <button>Complete</button>
                                </form>{% endif %}</td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            {% else %}
                <p>You have no tasks</p>
            {% endif %}
        </div>
    </main>
{% endblock content %}